function p = AUSW(x,dd,z)
% p = AUSW(x,dd,z)
%
% Interpolation nach dem Newton-Schema bei vorgegebenen Sttzstellen-Vektor x,
% dividierten Differenzen-Vektor dd gleicher Lnge sowie der zu untersuchenden
% Stelle z. 
%
% Das Programm wertet das Newtonsche Interpolationspolynom
% dd(1)+dd(2)*N_1(z)+...+dd(n-1)*N_{n-2}(z)+dd(n)*N_{n-1}(z) [wobei 
% N_k(z)=(z-x(1))*...*(z-x(k-1))*(z-x(k))] bei bereits berechneten dividierten 
% Differenzen dd an der Stelle z mit einem HORNER-ARTIGEM SCHEMA aus. 
% Ergebnis wird in p abgelegt
%
% -----------------------------------------------------------------------------
%
% Eingabe
% -------
% x         Sttzstellenvektor
% dd        Vektor der dividierten Differenzen
% z         Stelle, an der das Polynom ausgewertet werden soll
%
% -----------------------------------------------------------------------------
% 
% Ausgabe
% -------
% p         Wert des Interpolationspolynoms an der Stelle z

