% Interpoliere die Funktionen 1/(1+ 25*t*t), sqrt(|x|) mit Hilfe des Newtonschemas
film=0;

k=menu('Interpolation mittels Newtonschema',...
       'äquidistante Stützstellen',...
       'Tschebysheff-Stützstellen',...
       'Vergleich beider',...
       'Ende');

while k<4

      clear y z x;
      
      v=2:2:20;
      fehler=zeros(2,length(v));
      zeit  =zeros(2,length(v));
      
      j=1;
      if film
	 MV1=moviein(length(v));
	 MV2=moviein(length(v));
      end;
      
      lf=menu('Zu interpolierende Funktion',...
	      '1/(1+25x^2)',...
	      'sqrt(|x|)');
      if lf==1
	 fname='FUNKTION2';
      else
	 fname='FUNKTION1';
      end
       
      
      for n=v

	  if k==1 || k==3
	     % Teil i) 
	     tic;
	     % äquidistante St�tzstellen
	     t =-1:(2/n):1;
	     % zugehörige Funktionswerte
	     
	     f=feval(fname,t);

	     % auszuwertende Stellen 
	     x = t(1):((t(2)-t(1))/21.0):t(2);
	     for i = 2:length(t)-1
	         x = [x(1:length(x)-1),t(i):((t(i+1)-t(i))/21.0):t(i+1)];
	     end % for i
	     
	     % Interpolationspolynom an diesen Stellen
	     % 1. Schritt, berechne dividierte Differenzen
	     dd=DIVDIFF(t,f);
	     % 2. Schritt. Auswertung nach Hornerartigem Schema
            for i=1:length(x)
                y(i)=AUSW(t,dd,x(i));
            end  % for i
	     zeit(1,j)=toc;

	     % zugehoerige exakte Funktionswerte
	     z=feval(fname,x);

	     % Schaetzung fuer den maximalen Fehler
	     fehler(1,j)=max(abs(z-y)); 

	     % Grafik Funktion/Interpolationspolynom
	     figure(1);
	     plot(x,z,'-g',x,y,':r');
	     w=axis;
	     axis([w(1:2) -5 5]);
	     title('Interpolationspolynom (äquidistante Stützstellen)');
	     text(0.5,4,['n=' num2str(n)]);
	     xlabel('t');
	     ylabel('y');
	     if film 
	        MV=getframe;
		MV1(1:length(MV),j)=MV;
	     end;
	  end;
	     
	  if k==2 || k==3
	     % Teil ii) 
	     tic;
	     % Tschebyschow-Stützstellen
	     t = cos((2*(0:n)+1) * (pi/(2*(n+1))));
	     % zugehürige Funktionswerte
	     f = feval(fname,t);
	     % auszuwertende Stellen
	     x = t(1):((t(2)-t(1))/21.0):t(2);
	     for i = 2:length(t)-1
	         x = [x(1:length(x)-1),t(i):((t(i+1)-t(i))/21.0):t(i+1)];
	     end % for
     
	     % Interpolationspolynom an diesen Stellen
	     % 1. Schritt, berechne dividierte Differenzen
	     dd=DIVDIFF(t,f);
	     % 2. Schritt. Auswertung nach Hornerartigem Schema
	     for i=1:length(x)
	         y(i)=AUSW(t,dd,x(i));
	     end % for i
	     zeit(2,j)=toc;

	     % zugehoerige exakte Funktionswerte
	     z=feval(fname,x);

	     % Schaetzung fuer den maximalen Fehler
	     fehler(2,j)=max(abs(z-y)); 

	     % Grafik Funktion/Interpolationspolynom
	     figure(2);
	     plot(x,z,'-g',x,y,'--b');
	     w=axis;
	     axis([w(1:2) -0.5 1.5]);
	     title('Interpolationspolynom (Tschebyscheff-Stützstellen)');
	     text(0.5,1,['n=' num2str(n)]);
	     xlabel('t');
	     ylabel('y');
	     if film
	        MV=getframe;
		MV2(1:length(MV),j)=MV;
	     end;
	  end % if
	  
	  j=j+1;
      end % for



      figure(3);
      if k==1 || k==3
	 subplot(1,2,1);
	 semilogy(v,fehler(1,1:length(v)),'+r');
	 hold on
	 subplot(1,2,2);
	 plot(v,zeit(1,1:length(v)),'+r');
	 hold on
      end 
       
      if k==2 || k==3
	 subplot(1,2,1);
	 semilogy(v,fehler(2,1:length(v)),'ob');
	 subplot(1,2,2);
	 plot(v,zeit(2,1:length(v)),'ob');
      end 

      subplot(1,2,1);
      hold off
      title('Fehler zur Funktion');
      xlabel('n, `+` (äquidistant), `o` (Tschebyscheff)');
      ylabel('Fehler');
      subplot(1,2,2);
      hold off
      title('Rechenzeit');
      xlabel('n, `+` Teil i), `o` Teil ii)');
      ylabel('flops');

      if film
	 if k==1 || k==3
	    figure(1);
	    movie(MV1,1,1);
	 end % if
	 if k==2 || k==3
	    figure(2);
	    movie(MV2,1,1);
	 end % if
      end
       
      k=menu('Interpolation mittels Newtonschema',...
	     'äquidistante Stützstellen',...
	     'Tschebyscheff-Stützstellen',...
	     'Vergleich beider',...
	     'Ende');

end % while